from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, File, Int

Goalign_Diff_V0_1_0 = CommandToolBuilder(tool="goalign_diff", base_command=["goalign", "diff"], inputs=[ToolInput(tag="in_counts", input_type=Boolean(optional=True), prefix="--counts", doc=InputDocumentation(doc="Count differences instead of writting only identical characters")), ToolInput(tag="in_no_gaps", input_type=Boolean(optional=True), prefix="--no-gaps", doc=InputDocumentation(doc="Do not count gaps (only with --counts)")), ToolInput(tag="in_output", input_type=File(optional=True), prefix="--output", doc=InputDocumentation(doc="Diff output file (default 'stdout')")), ToolInput(tag="in_reverse", input_type=Boolean(optional=True), prefix="--reverse", doc=InputDocumentation(doc="Restore identical characters (.) using first sequence positions")), ToolInput(tag="in_align", input_type=File(optional=True), prefix="--align", doc=InputDocumentation(doc="Alignment input file (default 'stdin')")), ToolInput(tag="in_auto_detect", input_type=Boolean(optional=True), prefix="--auto-detect", doc=InputDocumentation(doc="Auto detects input format (overrides -p, -x and -u)")), ToolInput(tag="in_clustal", input_type=Boolean(optional=True), prefix="--clustal", doc=InputDocumentation(doc="Alignment is in clustal? default fasta")), ToolInput(tag="in_ignore_identical", input_type=Boolean(optional=True), prefix="--ignore-identical", doc=InputDocumentation(doc="Ignore duplicated sequences that have the same name and same sequences")), ToolInput(tag="in_input_strict", input_type=Boolean(optional=True), prefix="--input-strict", doc=InputDocumentation(doc="Strict phylip input format (only used with -p)")), ToolInput(tag="in_nexus", input_type=Boolean(optional=True), prefix="--nexus", doc=InputDocumentation(doc="Alignment is in nexus? default fasta")), ToolInput(tag="in_no_block", input_type=Boolean(optional=True), prefix="--no-block", doc=InputDocumentation(doc="Write Phylip sequences without space separated blocks (only used with -p)")), ToolInput(tag="in_one_line", input_type=Boolean(optional=True), prefix="--one-line", doc=InputDocumentation(doc="Write Phylip sequences on 1 line (only used with -p)")), ToolInput(tag="in_output_strict", input_type=Boolean(optional=True), prefix="--output-strict", doc=InputDocumentation(doc="Strict phylip output format (only used with -p)")), ToolInput(tag="in_phylip", input_type=Boolean(optional=True), prefix="--phylip", doc=InputDocumentation(doc="Alignment is in phylip? default fasta")), ToolInput(tag="in_seed", input_type=Int(optional=True), prefix="--seed", doc=InputDocumentation(doc="Random Seed: -1 = nano seconds since 1970/01/01 00:00:00 (default -1)")), ToolInput(tag="in_threads", input_type=Int(optional=True), prefix="--threads", doc=InputDocumentation(doc="Number of threads (default 1)"))], outputs=[ToolOutput(tag="out_output", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output", type_hint=File()), doc=OutputDocumentation(doc="Diff output file (default 'stdout')"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Goalign_Diff_V0_1_0().translate("wdl", allow_empty_container=True)

